﻿// -----------------------------------------------------------------------
//  <last-editor>黄深</last-editor>
//  <last-date>2023-01-31 16:19</last-date>
// -----------------------------------------------------------------------

using LinqToDB.Configuration;
using LinqToDB.Data;
using LinqToDB.DataProvider.PostgreSQL;

namespace KingMetalTemplateProject.Infrastructure.Database;

/// <summary>
///     DataBase Connection
/// </summary>
public class DataBaseConnection : DataConnection
{
    #region 初始化

    /// <summary>
    ///     初始化一个 <see cref="DataBaseConnection" /> 类型的新实例
    /// </summary>
    /// <param name="options"> 配置对象 </param>
    public DataBaseConnection(LinqToDBConnectionOptions options) : base(options)
    {
        InitMappingSchema();
    }

    /// <summary>
    ///     初始化一个 <see cref="DataBaseConnection" /> 类型的新实例
    /// </summary>
    /// <param name="connectionString"> 数据库连接字符串 </param>
    public DataBaseConnection(string connectionString) : base(PostgreSQLTools.GetDataProvider(PostgreSQLVersion.v95),
        connectionString)
    {
        InitMappingSchema();
    }

    #endregion 初始化

    #region 映射配置

    /// <summary>
    ///     映射配置
    /// </summary>
    public static void InitMappingSchema()
    {

    }

    #endregion
}