﻿// -----------------------------------------------------------------------
//  <last-editor>黄深</last-editor>
//  <last-date>2023-01-31 16:38</last-date>
// -----------------------------------------------------------------------

namespace KingMetal.Domains.Core.Grains;

/// <summary>
///     DbGrain
/// </summary>
public abstract class ObserverDbGrain : ObserverGrain<long>
{
    #region 初始化

    /// <inheritdoc />
    protected override Task Initialize()
    {
        EventHandlerRetryCount = 5;

        return base.Initialize();
    }

    #endregion

    #region 打印信息日志

    /// <summary>
    ///     打印信息日志
    /// </summary>
    /// <param name="ex">       异常信息 </param>
    /// <param name="eventMetadata">   事件元数据 </param>
    /// <param name="event"> 事件 </param>
    protected void LogError(Exception ex, EventMetadata eventMetadata, IEvent @event)
    {
        Logger.LogError(ex, "{eventName} Fail; {eventId}. {message};", @event.GetDefaultName(), eventMetadata.EventId,
            ex.Message);
    }

    #endregion 打印信息日志

    #region 打印错误日志

    /// <summary>
    ///     打印错误日志
    /// </summary>
    /// <param name="eventMetadata">    事件元数据 </param>
    /// <param name="event">  事件 </param>
    protected void LogInfo(EventMetadata eventMetadata, IEvent @event)
    {
        Logger.LogInformation("{eventName} Success; {eventId}.", @event.GetDefaultName(), eventMetadata.EventId);
    }

    #endregion 打印错误日志
}