﻿// -----------------------------------------------------------------------
//  <last-editor>黄深</last-editor>
//  <last-date>2023-01-31 16:38</last-date>
// -----------------------------------------------------------------------

namespace Orleans;

/// <summary>
///     GrainFactory 扩展
/// </summary>
public static class GrainFactoryExtensions
{
    /// <summary>
    ///     生成整形全局唯一ID
    /// </summary>
    /// <param name="grainFactory"></param>
    /// <returns></returns>
    public static async Task<long> NewIntegerIdAsync(this IGrainFactory grainFactory)
    {
        return await grainFactory.GetUniqueIdService().NewIntegerId();
    }

    /// <summary>
    ///     生成业务代码
    /// </summary>
    /// <param name="grainFactory"></param>
    /// <param name="bizType"></param>
    /// <param name="prefix"></param>
    /// <returns></returns>
    public static async Task<string> NewStringIdAsync(this IGrainFactory grainFactory, int bizType, bool prefix = false)
    {
        var code = bizType.ToString().PadLeft(2, '0'); //.ToInt32().ToString().PadLeft(2, '0');
        return await grainFactory.GetUniqueIdService().NewStringId(code, prefix);
    }
}